/**
 * File: ImplementionOne.cs
 * Article: C# Reflection and Dynamic Method Invocation
 * Copyright (c) 2000, Gopalan Suresh Raj. All Rights Reserved.
 * Compile with: csc /target:library ImplementationOne.cs IBase.cs
 */

using System;

namespace com.icommware {

 /**
  * A Class that implements the IBase interface
  */
 class ImplementationOne : IBase {
 
  string remark = "Remark of ImplementationOne";
  static int DELTAFACTOR = 10;
 
  ImplementationOne () {
   Console.WriteLine ("Invoking ImplementationOne...");
  }
  
  public string execute (string data) {
   remark = data;
   Console.WriteLine ("ImplementationOne's execute() remark is : {0}", remark);
   return remark;
  }
  
  public double compute (int param1, double param2) {
   Console.WriteLine ("ImplementationOne's compute() method invoked...");
   return param1*param2*DELTAFACTOR;
  }
 }
 
 /**
  * A generic Structure
  */
 struct StructOne {
  int x;
  double y;
  
  double assign () {
   x = 10;
   y = 2.8;
   return x*y;
  }
 }
}
