/**
 * File: ReflectTypes.cs
 * Article: C# Reflection and Dynamic Method Invocation
 * Copyright (c) 2000, Gopalan Suresh Raj. All Rights Reserved.
 * Compile with: csc ReflectTypes
 * Run as: ReflectTypes <library>
 *         eg., ReflectTypes ImplementationOne.dll
 */

using System;
using System.Reflection;

/**
 * Develop a class that can Reflect all the Types available in an Assembly
 */
class ReflectTypes {

 public static void Main (string[] args) {
 
  // List all the types in the assembly that is passed in as a parameter
  Assembly assembly = Assembly.LoadFrom (args[0]);
  
  // Get all Types available in the assembly in an array
  Type[] typeArray = assembly.GetTypes ();
  
  Console.WriteLine ("The Different Types of Classes Available in {0} are:", args[0]);
  Console.WriteLine ("_____");
  // Walk through each Type and list their Information
  foreach (Type type in typeArray) {
   // Print the Class Name
   Console.WriteLine ("Type Name : {0}", type.FullName);
   // Print the name space
   Console.WriteLine ("Type Namespace : {0}", type.Namespace);
   // Print the Base Class Name
   Console.WriteLine ("Type Base Class : {0}", (type.BaseType != null)?type.BaseType.FullName:"No Base Class Found...");
   Console.WriteLine ("_____");
  }
 }
}